// Temperature and Humid Meter
// 2017-05-28  T. Nakagawa

#include "DHT22.h"
#include "IM50175H.h"

#define DHT22_PIN 7
#define LCD_PIN_LATCH 9
#define LCD_PIN_DATA 10
#define LCD_PIN_CLOCK 11

DHT22 dht(DHT22_PIN);
IM50175H lcd(LCD_PIN_LATCH, LCD_PIN_DATA, LCD_PIN_CLOCK);

void setup() {
  lcd.buffer[3] = 12;
  lcd.buffer[7] = 13;
}

void writeBuffer(uint16_t value, uint8_t *buffer) {
  for (uint8_t i = 0; i < 3; i++) {
    buffer[2 - i] = (uint8_t)(value % 10);
    value /= 10;
  }
}

void loop() {
  delay(3000UL);
  static uint16_t temp, humi;
  if (!dht.read(&temp, &humi)) {
    temp = 999;
    humi = 999;
  }
  writeBuffer(temp, lcd.buffer);
  writeBuffer(humi, lcd.buffer + 4);
  lcd.refresh();
}

